#include <stdio.h>
#include <stdlib.h>

#include "cpu.h"

#define STAGE_MIDDLE 20
#define STAGE_FINAL 48

#define EVA_TYPENUM 4
#define EVA_CANPUTNUM 0
#define EVA_KOMANUM 1
#define EVA_KOMAPOS 2
#define EVA_ABSKOMA 3

int minMax(int State[][SIZE], int depth, int Turn, int alpha, int beta);
int evaluate(int State[][SIZE]);
int evaCanPutNum(int State[][SIZE]);
int evaKomaNum(int State[][SIZE]);
int evaKomaPos(int State[][SIZE]);
int evaAbsKoma(int State[][SIZE]);
int absLink(int State[][SIZE], int x, int y, int dx, int dy);

int com;
int maxDepth;
int power[3][EVA_TYPENUM] = {
  /*{1, 0, 1, 0},
  {1, 0, 1, 1},
  {0, 1, 0, 0}*/
  {1, 0, 1, 0},
  {0, 2, 1, 1},
  {0, 1, 0, 0}
};

Pos p1151hara(int State[][SIZE], int Turn)
{
	Pos p;
	int tmp;

	com = Turn;
	
	if (now_his_no >= STAGE_FINAL) {
	  maxDepth = 12;
	}
	else {
	  maxDepth = 4;
	}

	tmp = minMax(State, maxDepth, com, -9999, 9999);
	p.x = tmp % SIZE;
	p.y = tmp / SIZE;
	if (p.x < 0 || p.y < 0) {
	  p.get = 0;
	}
	else {
	  p.get = Num_of_othello(State, com, p.x, p.y, NULL);
	}

	return p;
}

int minMax(int State[][SIZE], int depth, int Turn, int alpha, int beta) {
  int i, j;
  int x = -1, y = -1;
  int putFlg = 0;
  int tmp;
  int **PseudoState1;
  int PState1[SIZE][SIZE];
  
  if (depth == 0) return evaluate(State);
  if (Turn == com) alpha = -9999;
  else beta = 9999;
  
  for (i = 0; i < SIZE; i++) {
    for (j = 0; j <SIZE; j++) {
      if (Num_of_othello(State, Turn, i, j, NULL) > 0) {
	putFlg = 1;

	PseudoState1 = Put_othello(State, Turn, i, j);
	PseudoState1[i][j] = Turn;
	CopyState(PseudoState1, PState1);
	freeState(PseudoState1);

	tmp = minMax(PState1, depth - 1, Turn * (-1), alpha, beta);
	
	if (Turn == com) {
	  if (tmp >= alpha) {
	    x = i;
	    y = j;
	    alpha = tmp;
	  }
	  if (alpha > beta) {
	    return alpha;
	  }
	}
	else {
	  if (tmp <= beta) {
	    x = i;
	    y = j;
	    beta = tmp;
	  }
	  if (alpha > beta) {
	    return beta;
	  }
	}
      }
    }
  }
  
  if (putFlg) {
    if (depth == maxDepth) {
      return x + (y * 8);
    }
    else if (Turn == com) {
      return alpha;
    }
    else {
      return beta;
    }
  }
  else {
    tmp = minMax(State, depth - 1, Turn * (-1), alpha, beta);
    return tmp;
  }
    
}

/* ]֐ */
int evaluate(int State[][SIZE]) {
  int value = 0;

  /*  */
  if (now_his_no < STAGE_MIDDLE) {
    value += evaCanPutNum(State) * power[0][EVA_CANPUTNUM];
    value += evaKomaNum(State) * power[0][EVA_KOMANUM];
    value += evaKomaPos(State) * power[0][EVA_KOMAPOS];
    value += evaAbsKoma(State) * power[0][EVA_ABSKOMA];
  }
  /*  */
  else if (now_his_no < STAGE_FINAL) {
    value += evaCanPutNum(State) * power[1][EVA_CANPUTNUM];
    value += evaKomaNum(State) * power[1][EVA_KOMANUM];
    value += evaKomaPos(State) * power[1][EVA_KOMAPOS];
    value += evaAbsKoma(State) * power[1][EVA_ABSKOMA];
  }
  /* I */
  else {
    value += evaKomaNum(State) * power[2][EVA_KOMANUM];
  }

  return value;
}

/* \萔ŕ] */
int evaCanPutNum(int State[][SIZE]) {
  int i, j;
  int value = 0;
  
  for (i = 0; i < SIZE; i++) {
    for (j = 0; j < SIZE; j++) {
      if (Num_of_othello(State, com, i, j, NULL)) {
	value++;
      }
    }
  }

  return value;
}

/* ̐ŕ] */
int evaKomaNum(int State[][SIZE]) {
  int i, j;
  int value = 0;

  for (i = 0; i < SIZE; i++) {
    for (j = 0; j < SIZE; j++) {
      if (State[i][j] == com) {
	value++;
      }
    }
  }
  
  return value;
}

/* ̈ʒuŕ] */
int evaKomaPos(int State[][SIZE]) {
  int i, j;
  int value = 0;
  int boardValue[SIZE][SIZE] = {
    {16, -4, 4, -1, -1, 4, -4, 16},
    {-4, -12, -2, -1, -1, -2, -12, -4},
    {4, -2, 2, -2, -2, 2, -2, 4},
    {-1, -1, -2, 0, 0, -2, -1, -1},
    {-1, -1, -2, 0, 0, -2, -1, -1},
    {4, -2, 2, -2, -2, 2, -2, 4},
    {-4, -12, -2, -1, -1, -2, -12, -4},
    {16, -4, 4, -1, -1, 4, -4, 16}
  };

  
  int tv = -4, tv2 = -12;

  if (State[0][0] == com) {
    boardValue[1][0] = tv;
    boardValue[0][1] = tv;
    boardValue[1][1] = tv2;
  }
  if (State[7][0] == com) {
    boardValue[6][0] = tv;
    boardValue[7][1] = tv;
    boardValue[6][1] = tv2;
  }
  if (State[7][7] == com) {
    boardValue[6][7] = tv;
    boardValue[7][6] = tv;
    boardValue[6][6] = tv2;
  }
  if (State[0][7] == com) {
    boardValue[1][7] = tv;
    boardValue[0][6] = tv;
    boardValue[1][6] = tv2;
  }
  
  for (i = 0; i < SIZE; i++) {
    for (j = 0; j < SIZE; j++) {
      if (State[i][j] == com) {
	value += boardValue[i][j];
      }
    }
  }

  return value;
}

/* ΎȂʒuŕ] */
int evaAbsKoma(int State[][SIZE]) {
  int value = 0;

  if (State[0][0] == com) {
    value += absLink(State, 0, 0, 1, 0);
    value += absLink(State, 0, 0, 0, 1);
  }
  if (State[SIZE - 1][0] == com) {
    value += absLink(State, SIZE - 1, 0, 0, 1);
    value += absLink(State, SIZE - 1, 0, -1, 0);
  }
  if (State[SIZE - 1][SIZE - 1] == com) {
    value += absLink(State, SIZE - 1, SIZE - 1, -1, 0);
    value += absLink(State, SIZE - 1, SIZE - 1, 0, -1);
  }
  if (State[0][SIZE - 1] == com) {
    value += absLink(State, 0, SIZE - 1, 0, -1);
    value += absLink(State, 0, SIZE - 1, 1, 0);
  }

  return value;
}
int absLink(int State[][SIZE], int x, int y, int dx, int dy) {
  int cnt = 0;
  while (State[x += dx][y += dy] == com) {
    cnt++;
    if (cnt >= SIZE / 2 - 1) break;
  }

  return cnt;
}















